import java.io.File;
import java.util.TreeMap;
import java.util.Map;
import org.pd.parser.*;

public class Actions extends RuleReader {
	private TreeMap<String, String> actions;

	public Actions(File defFile, File inDir) {
		super(defFile, inDir);
		actions = new TreeMap<String, String>();
	}

	public static void main(String[] args) {
		Actions a;

		if (args.length < 2) {
			System.err.println("usage: Actions deffile inputdir");
			System.exit(1);
		}

		a = new Actions(new File(args[0]), new File(args[1]));
		a.parse();
		a.dump();
	}

	public void handleExtraction(String type, String name, String matched) {
		actions.put(name, matched);
	}

	public void dump() {
		System.out.println("package rs;");
		System.out.println("public class ActionConstants {");
		for (Map.Entry e : actions.entrySet())
			System.out.println("\tpublic static final int " + e.getKey() + " = "
					+ e.getValue() + ";");
		System.out.println("}");
	}

	public String findVariable(String var) {
		return getVariables().get(var);
	}
}
