package org.pd.parser;

import java.io.File;
import java.io.FileInputStream;

public class SourceFile {
	private String name;
	private String contents;
	private String[] lines;

	public SourceFile(File f) {
		try {
			byte[] data = new byte[(int)f.length()];
			FileInputStream fin = new FileInputStream(f);
			fin.read(data);
			fin.close();
			
			this.name = f.getName();
			this.contents = new String(data);
		} catch (Exception e) {
			throw new RuntimeException("Exception in SourceFile: " + e);
		}
	}

	public SourceFile(String name, String contents) {
		this.name = name;
		this.contents = contents;
	}

	public String getName() {
		return name;
	}

	public String getContents() {
		return contents;
	}

	public String[] getLines() {
		if (lines == null)
			lines = contents.split("\n");

		return lines;
	}

	public void setName(String name) {
		this.name = name;
	}

	public void setContents(String contents) {
		this.contents = contents;
	}

	public void setLines(String[] lines) {
		this.lines = lines;
	}
}
