#!/usr/bin/perl
# vim: ts=2 sw=2 ft=perl
use strict;

my $walkptrn = qr/if\s*\(player != null\)\s*?{\s*?doWalkTo\((.*?)\);/s;
my $actionptrn = qr/void doAction\((\w+) (\w+), (\w+) (\w+)\).*?int \w = menuActionCmd\d\[(\w)\];/s;

die "usage: $0 path/to/client.java outputdir" if scalar @ARGV < 2;

my $out_bmm = "$ARGV[1]/BotMiddleMan.java";
my $out_amm = "$ARGV[1]/AccessorMiddleMan.java";

local $/;
open my $fd, "<$ARGV[0]" or die "couldn't open input file $ARGV[0]: $!";
my $client = <$fd>;
close $fd;

if ($client =~ m/$walkptrn/) {
	(my $params = $1) =~ s/\s+/ /g;
	$params =~ s/\(\(Entity\) \(player\)\)\.smallX\[0\]/destX/;
	$params =~ s/\(\(Entity\) \(player\)\)\.smallY\[0\]/destY/;
	$params =~ s/\(\(Entity\) \(myPlayer\)\)\.smallX\[0\]/myX/g;
	$params =~ s/\(\(Entity\) \(myPlayer\)\)\.smallY\[0\]/myY/g;
	$params =~ s/(\ba\w+\b,)/rs.$1/;
	open my $ammfd, ">$out_amm" or die "couldn't open output file $out_amm: $!";
	print $ammfd <<__EOF__
package rs;
import aryan.Bot;

public class AccessorMiddleMan {
	public static Bot rs;
	public boolean doWalkTo(int myX, int myY, int destX, int destY) {
		return rs.doWalkTo($params);
	}
}
__EOF__
} else {
	print "couldn't match the doWalkTo pattern\n";
	exit 1;
}

if ($client =~ m/$actionptrn/) {
	my @types = ($1, $3);
	my ($i, $j) = ($2, $4);
	my $var = $5;
	open my $bmmfd, ">$out_bmm" or die "couldn't open output file $out_bmm: $!";
	print $bmmfd <<__EOF__
package rs;

public class BotMiddleMan extends client {
	public static boolean debugActions = false;
	public int[] actionJack;

	public void doAction($types[0] $i, $types[1] $j) {
		if (actionJack != null && actionJack.length == 4) {
			menuActionID[$var] = actionJack[0];
			menuActionCmd1[$var] = actionJack[1];
			menuActionCmd2[$var] = actionJack[2];
			menuActionCmd3[$var] = actionJack[3];
			actionJack = null;
		}

		if (debugActions) {
			int a = menuActionID[$var];
			int b = menuActionCmd1[$var];
			int c = menuActionCmd2[$var];
			int d = menuActionCmd3[$var];
			System.out.println(a + "=" + b + "," + c + "," + d);
		}

		super.doAction($i, $j);
	}
}
__EOF__
}
